/**************************************************
*  xZTɂ郊R
*   H\
*   X,Y,ZꂼAN4,5,6֒ڐڑ
**************************************************/
#include  <16f785.h>
// RtBM[Vݒƃn[hEFAݒ
#fuses INTRC,NOWDT,NOPROTECT,PUT,BROWNOUT,MCLR,NOIESO,NOFCMEN
#device ADC=10
#use delay(CLOCK = 8000000)
#use rs232(BAUD=1200, XMIT=PIN_B6) 
#use FAST_IO(A)
#use FAST_IO(B)
#use FAST_IO(C)
/*** 萔Aϐ̐錾` ****/
signed long Xdata,Ydata, Zdata;
signed long M1data, M2data;
unsigned int  Direction;

/*********** main ֐ **************/
void main(void)
{
	set_tris_A(0x0F);							// RA0-3 input
	set_tris_B(0x00);							// all Output
	set_tris_C(0xF7);							// SW,AI is input
	setup_adc(ADC_CLOCK_DIV_16);				// A/D ݒ	
	setup_adc_ports(sAN4 | sAN5 | sAN6);		// AN4,5,6

	/********* C[v *************/
	while(1)
	{
		/// X,Y,Z̃f[^
		set_adc_channel(4);					// Xf[^
		delay_us(40);
		Xdata = read_adc();
		set_adc_channel(5);					// Yf[^
		delay_us(40);
		Ydata = read_adc();
		set_adc_channel(6);					// Zf[^
		delay_us(40);
		Zdata = read_adc();
		// xf[^ւ̕ϊ
		if(Ydata > 0x220){					// iH
			Direction = 0;					// iZbg
			Ydata = 5*(Ydata - 0x200);			// xݒ
			if(Ydata > 0x3FF)
				Ydata = 0x3FF;
			output_low(PIN_B5);
		}
		else{
			if(Ydata < 0x1E0) {				// OiH
				Direction = 1;				// OiZbg
				Ydata = 5*(0x200 - Ydata);		// xݒ
				if(Ydata > 0x3FF)				// `FbN
					Ydata = 0x3FF;
				output_high(PIN_B5);			// ڈ
			}
			else{
				Direction = 2;				// ~Zbg
				Ydata = 0;					// x[
			}
		}
		// 񐧌f[^ւ̕ϊ
		if(Xdata >= 0x210){ 					// E񂩁H
			Xdata = (Xdata - 0x200);			// 񐧌
			M1data = Ydata + Xdata;			// M1
			if(M1data > 0x3FF)				// `FbN
				M1data = 0x3FF;
			M2data = Ydata - Xdata;			// M2
			if(M2data < 0)					// `FbN
				M2data = 0;
		}
		else {
			if(Xdata < 0x1F0){				// 񂩁H
				Xdata = (0x200  - Xdata);		// 񐧌
				M2data = Ydata + Xdata;		// M2
				if(M2data > 0x3FF)			// `FbN
					M2data = 0x3FF;			
				M1data = Ydata - Xdata;		// M1
				if(M1data < 0)				// `FbN
					M1data = 0;
			}
			else{
				Xdata = 0;					// i	
				M1data = Ydata;				// M1,M2x
				M2data = Ydata;
			}
		}

		/// f[^M
		putc('S');
		putc('S');
		putc(Direction);
		putc((unsigned char)(M1data >> 8));
		putc((unsigned char)(M1data & 0x00FF));
		putc((unsigned char)(M2data >> 8));
		putc((unsigned char)(M2data & 0x00FF));
		// ]QA
		putc(~Direction);
		putc(~(unsigned char)(M1data >> 8));
		putc(~(unsigned char)(M1data & 0x00FF));
		putc(~(unsigned char)(M2data >> 8));
		putc(~(unsigned char)(M2data & 0x00FF));
		putc('E');
		delay_ms(15);
	}
}
